#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define VPCALC_SECTION	"DEV"
#define VPCALC_SUBSECT	"NONE"

#include "../config.h"
#include "../include/types.h"
#include "../include/debug.h"

#include "../include/mem.h"
#include "../include/gfx.h"

#include "../include/mem.h"
#include "../include/gfx.h"

#include "../include/device.h"

typedef struct _device_o {
	uint8 keys[SDLK_LAST];

	mem_o mem;
	gfx_o gfx;
} _device_o;

device_o device_new(mem_o mem, gfx_o gfx)
{
	_device_o *new;

	new = (_device_o *) malloc(sizeof(_device_o));

	if (new != NULL) {
		memset(new, 0, sizeof(_device_o));

		new->mem = mem;

		new->gfx = gfx;
		gfx_activate(new->gfx, 1);
		gfx_set_contrast(new->gfx, 0x0a);
		gfx_set_screen_addr(new->gfx, 0xfc00);
	}

	return (device_o)new;
}

void device_del(device_o device)
{
	_device_o *_device = (_device_o *)device;

	free(_device);
}

void device_keydown(device_o device, SDLKey key)
{
	_device_o *_device = (_device_o *)device;

	_device->keys[key] = 0xff;

	_report("key down: %i", key);
}

void device_keyup(device_o device, SDLKey key)
{
	_device_o *_device = (_device_o *)device;

	_device->keys[key] = 0;

	_report("key up: %i", key);
}

void device_out(device_o device, uint port, uint data)
{
	_device_o *_device = (_device_o *)device;

	_warn_report("unknown output port! %i", port);
}

uint device_in(device_o device, uint port)
{
	_device_o *_device = (_device_o *)device;

	_warn_report("unknown input port! %i", port);

	return port;
}

void device_map_sleep(device_o device, int *ptr)
{
	/* This function intentionally left blank. */
}
